<template>
  <q-page class="q-pa-xl">
    <div
      v-if="Object.keys(currentQuiz).length && currentQuiz.constructor === Object"
      class="q-pa-xl row items-start justify-evenly q-gutter-xl"
    >
      <q-card flat bordered class="col-4">
        <q-card-section>
          <div class="text-h6">Tiene una evaluación pendiente</div>
        </q-card-section>
        <q-card-section class="q-pt-none">
          Si desea continuar con la evaluación anterior, hagá click en "Continuar". Si desea crear una evaluación nueva, utilice el formulario a continuación.
        </q-card-section>
        <q-card-section>
          <q-btn label="Continuar" color="secondary" v-bind:to="{ path: '/quiz/creation/add', query: { creating: true }}"/>
        </q-card-section>
      </q-card>
    </div>
    <q-form
      v-on:submit="onSubmit"
      v-on:reset="onReset"
      class="q-pa-md q-gutter-md row"
    >
      <div class="column col-md-10">
        <div>
          <q-input
            filled
            v-model="name"
            label="Nombre de la evaluación *"
            hint="Nombre para reconocer la evaluación"
            hide-hint
            lazy-rules
            v-bind:rules="[ val => val && val.length > 0 || 'Ingrese un nombre, por favor.']"
          />
          <q-select
            filled
            outlined
            v-model="area"
            v-bind:options="options"
            emit-value
            v-on:filter="filterFn"
            option-value="label"
            new-value-mode="add-unique"
            multiple
            use-input
            use-chips
            hide-dropdown-icon
            clearable
            hide-hint
            label="Añada etiquetas de área a su pregunta *"
            hint="Escriba y presione enter. Puede ingresar cuantas quiera."
            lazy-rules
            v-bind:rules="[ val => val && val.length > 0 || 'Ingrese una etiqueta, por favor.']"
          />
        </div>
        <div class="row q-gutter-md">
          <div class="column col-sm-5">
            <q-input
              filled
              v-model="nQuestions"
              type="number"
              label="Número de Preguntas *"
              hint="Número de preguntas"
              hide-hint
              lazy-rules
              v-bind:rules="[ val => val > 0 || 'Ingrese un número, por favor.']"
            />
            <q-select
              filled
              outlined
              v-model="themes"
              v-bind:options="options"
              v-on:filter="filterFn"
              v-bind:option-value="(opt) => ({ name: opt.label, label: opt.label, number: 0 })"
              emit-value
              multiple
              use-input
              use-chips
              hide-dropdown-icon
              clearable
              hide-hint
              v-on:new-value="createTag"
              label="Añada etiquetas de temas y contenidos a su pregunta *"
              hint="Escriba y presione enter. Puede ingresar cuantas quiera."
              lazy-rules
              v-bind:rules="[ val => val && val.length > 0 || 'Ingrese una etiqueta, por favor.']"
            />

            <q-input
              v-for="(theme, index) in themes"
              v-bind:key="100 - index"
              filled
              v-model.number="theme.number"
              type="number"
              v-bind:label="'Número de preguntas por ' + theme.name + ' *'"
              hint="Número de preguntas por habilidad"
              hide-hint
              lazy-rules
              v-bind:rules="[ val => val > 0 && val <= nQuestions || 'Ingrese un número valido, por favor.']"
            />
          </div>
          <div class="column col-sm-5">
            <q-input
              filled
              v-model.number="nPoints"
              type="number"
              label="Puntaje total de la prueba *"
              hint="Puntaje total de esta prueba"
              hide-hint
              lazy-rules
              v-bind:rules="[ val => val > 0 || 'Ingrese un número, por favor.']"
            />
            <q-select
              filled
              outlined
              v-model.number="skills"
              v-bind:options="options"
              emit-value
              v-bind:option-value="(opt) => ({ name: opt.label, label: opt.label, number: 0 })"
              v-on:filter="filterFn"
              multiple
              use-input
              use-chips
              hide-dropdown-icon
              clearable
              hide-hint
              v-on:new-value="createTag"
              label="Añada etiquetas de dificultad y habilidad a su pregunta *"
              hint="Escriba y presione enter. Puede ingresar cuantas quiera."
              lazy-rules
              v-bind:rules="[ val => val && val.length > 0 || 'Ingrese una etiqueta, por favor.']"
            />
            <q-input
              v-for="(skill, index) in skills"
              v-bind:key="index"
              filled
              v-model.number="skill.number"
              type="number"
              v-bind:label="'Número de preguntas por ' + skill.name + ' *'"
              hint="Número de preguntas por habilidad"
              hide-hint
              lazy-rules
              v-bind:rules="[ val => val > 0 && val <= nQuestions || 'Ingrese un número valido, por favor.']"
            />
          </div>
        </div>
        <div class="">
          <q-btn label="Crear prueba" type="submit" color="primary" v-bind:loading="workState"/>
          <q-btn label="Cancelar" type="reset" color="primary" flat class="q-ml-sm" />
        </div>
      </div>
    </q-form>
  </q-page>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  name: 'QuizCreation',
  data () {
    return {
      name: '',
      options: [],
      tagOptions: [],
      nQuestions: 0,
      nPoints: 0,
      area: [],
      themes: [],
      skills: []
    }
  },
  mounted () {
    if (this.$route.query.error) {
      this.$q.notify({
        message: 'Hubo un error en el acceso.',
        color: 'negative',
        icon: 'warning'
      })
    }
    this.$connection.get('api/tag/list')
      .then(response => {
        this.tagOptions = response.data
        this.options = this.tagOptions
      })
      .catch(() => {
        this.$q.notify({
          message: 'Hubo un error al recuperar las sugerencias.',
          color: 'negative',
          icon: 'warning'
        })
      })
  },
  computed: {
    ...mapGetters({
      userId: 'auth/getId',
      currentQuiz: 'current/getCurrentQuiz',
      workState: 'current/getWorkState'
    })
  },
  methods: {
    filterFn (val, update, abort) {
      if (val.length < 2) {
        abort()
        return
      }
      update(() => {
        const needle = val.toLowerCase()
        this.options = this.tagOptions.filter(v => v.label.toLowerCase().indexOf(needle) > -1)
      })
    },
    createTag (val, done) {
      done({
        name: val,
        label: val,
        number: 0
      }, 'add-unique')
    },
    onSubmit () {
      const tSkills = this.skills.map((item) => parseInt(item.number)).reduce((a, b) => a + b)
      const tThemes = this.themes.map((item) => parseInt(item.number)).reduce((a, b) => a + b)
      if (tSkills === parseInt(this.nQuestions) && tThemes === parseInt(this.nQuestions)) {
        this.$store.dispatch('current/setCurrentQuiz', [
          {
            name: this.name,
            nquestions: parseInt(this.nQuestions),
            npoints: parseInt(this.nPoints),
            area: this.area,
            themes: this.themes.map((item) => item.name),
            skills: this.skills.map((item) => item.name),
            autorId: this.userId
          },
          this.area,
          this.themes,
          this.skills
        ])
          .then(() => this.$router.push({ path: '/quiz/creation/add', query: { creating: true } }))
          .catch(() => this.$store('auth/logOut'))
      } else {
        this.$q.notify({
          message: 'Cantidad total de preguntas (' + this.nQuestions + ') no coincide con cantidad de preguntas por tema (' + tThemes + ') o habilidad (' + tSkills + ').',
          color: 'negative',
          icon: 'warning'
        })
      }
    },
    onReset () {
      this.$router.go(-1)
    }
  }
}
</script>
